/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.5b Standard
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Rorganisation de la commande du moteur
pas  pas du Pousse Seringue (Correction TP3 et TP4)
Version : 2     Rvision: 1
Cr le : 26/10/2010
Mise  jour    : 26/10/2010
Author  : Philippe Mariano
Company : SIPEM
Comments: Choix de la seringue et rglage du dbit
 partir d'un clavier et d'un afficheur
Chip type               : ATmega8535
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 128
*****************************************************/

#include <mega8535.h>
//-------------------------------------------------------------------------------------------------------
// Librairies non gnres par Wizard (rajoutes manuellement)
// -----------------------------------------------------------------------------------------------------
#include "ssi2.h"     // Contient les fonctions Lire_BP, Affiche_LCD, Regdebit, Select_Seringue
#include <delay.h>    // Contient la fonction delay_ms
#include <stdio.h>    // Contient la fonction sprintf
//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
// Frquence du quartz prsent sur la carte SSI V1
// -----------------------------------------------------------------------------------------------------
#define FQUARTZ	    8E6
//-------------------------------------------------------------------------------------------------------
// Bus de commande du moteur
// -----------------------------------------------------------------------------------------------------
#define VPH 	    PORTB
//-------------------------------------------------------------------------------------------------------
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm
#include <lcd.h>
//-------------------------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------------------------
// Declare your global variables here
//-------------------------------------------------------------------------------------------------------
// type 	            nom              				    Description
//-------------------------------------------------------------------------------------------------------
char display_buffer_ligne0[17]; 						    // Tampon ligne 0 de l'afficheur LCD2x16
char display_buffer_ligne1[17]; 						    // Tampon ligne 1 de l'afficheur LCD2x16
enum EtatMenu{Arret, Marche, ReglageDebit, ChoixSeringue}   // Etats du graphe des transitions "Menu"
			Menu=Arret, Menu_1=Marche;
enum TypeSeringue{Terumo50CC,Monoject50CC,BD20CC}           // Seringue choisie
            seringue = BD20CC;
enum EtatMoteur{Etat0, Etat1, Etat2, Etat3} ; 	            // Etats du graphe des transitions "Moteur"
unsigned int Vtimer; 							            // Rglage de la frquence de rotation du
                                                            // moteur pas  pas
//-------------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------------
// Timer 1 overflow interrupt service routine
// Sous programme d'interruption: "Gnration des pas du moteur"
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
    static unsigned char Etat = Etat0;
    TCNT1 = Vtimer; // rechargement du timer 1

    switch(Etat)
	 {
      case Etat0 : VPH = 9; Etat = Etat1; break;            // <- complter par les lves dans le TP3
	  case Etat1 : VPH = 5; Etat = Etat2; break;			// <- complter par les lves dans le TP3
	  case Etat2 : VPH = 6; Etat = Etat3; break;            // <- complter par les lves dans le TP3
	  case Etat3 : VPH = 10; Etat = Etat0; break;           // <- complter par les lves dans le TP3
	 }
}
//-------------------------------------------------------------------------------------------------------

// =====================================================================================================
// Programme principal
// =====================================================================================================
void main(void)
{
// -----------------------------------------------------------------------------------------------------
// Declare your local variables here
// -----------------------------------------------------------------------------------------------------
// type 	                nom              				Description
// -----------------------------------------------------------------------------------------------------
char Type_Seringue[3][7]={"TERUMO","BD50CC","BD20CC"};
unsigned int dizaines=0, unites=0, diziemes=0; 	// slection du dbit  dizaines unites.diziemes ml/h
unsigned char BP;	 							// BP = code ou tat de la touche slectionne
float FPH; 										// frquence calcule  partir de la consigne de dbit
unsigned int dix_C_debit; 						// dix_C_debit = 100*dizaines + 10*unites + diziemes
// -----------------------------------------------------------------------------------------------------

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=P State4=P State3=P State2=P State1=P State0=P
PORTA=0x3F;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State7=T State6=T State5=T State4=0 State3=0 State2=0 State1=0 State0=0
PORTB=0x00;                                     // <- complter par les lves dans le TP3
DDRB=0x1F;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// LCD module initialization
lcd_init(16);

// -------------------------------------- Message d'accueil --------------------------------------------
lcd_clear();
sprintf(display_buffer_ligne0,"TP3, TP4 PS Corr");
sprintf(display_buffer_ligne1,"----------------");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
delay_ms(3000);
// -----------------------------------------------------------------------------------------------------

while (1)
      {
      BP = Lire_BP();

      switch (Menu)
      {
        case Arret : if (Menu_1 != Menu)
                       {
                            PORTB = 0x00;  	// Dsactivation du moteur
                            TIMSK=0x00; 	// Inhibition interruption dbordement timer 1
                            #asm("cli")     // Global disnable interrupts

                            sprintf(display_buffer_ligne0,"ETR>CH_S OK>RG_D");
                    	    sprintf(display_buffer_ligne1,"         SET>RUN");
                    	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                       }

                       if (BP == OK) Menu = ReglageDebit;
                      		else if (BP == SET) Menu = Marche;
                      	       		else if (BP == ENTR) Menu = ChoixSeringue;
                      		               else Menu = Arret;
       		           Menu_1 = Arret;
        break;

        case Marche : if (Menu_1 != Menu)
                       {
                          dix_C_debit = 100*dizaines + 10*unites + diziemes;

                       	  switch (seringue)   // Calcul de FPH=f(C_debit)
                         	{
                         	 case Terumo50CC : FPH = (0.2*dix_C_debit)/10; break;       // <- complter par les lves dans le TP4
                          	 case Monoject50CC : FPH = (0.2396*dix_C_debit)/10; break;  // <- complter par les lves dans le TP4
                          	 case BD20CC : FPH = (0.4667*dix_C_debit)/10; break;        // <- complter par les lves dans le TP4
                         	}

                          //calcul de la valeur initiale du timer1
                          Vtimer =  (unsigned int)(65536 - FQUARTZ/(4096*FPH)); 	    // <- complter par les lves dans le TP4

                          TIMSK=0x04; // Autorisation interruption dbordement sur timer1
                          #asm("sei") // Global enable interrupts

                          sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
                          sprintf(display_buffer_ligne1,"      ECHAP>STOP");
                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);

                        }

       		            if (BP == ECHAP) Menu = Arret;
                      		    else Menu = Marche;

                        Menu_1 = Marche;
        break;

        case ChoixSeringue: if (Menu_1 != Menu)
                            {
                               	seringue = Menu_Select_Seringue();

                         	    switch(seringue)
                         	    {
                         	        case Terumo50CC : sprintf(display_buffer_ligne0,"Srg=TERUMO 50CC"); break;
                         	        case Monoject50CC : sprintf(display_buffer_ligne0,"Srg=MONO/BD 50CC"); break;
                         	        case BD20CC : sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
                                    default:  sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
                         	    }

                         	    sprintf(display_buffer_ligne1,"ECHP>Arr OK>RG_D");
                         	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);

                            }

                            if (BP == ECHAP) Menu = Arret;
                      		    else if (BP == OK) Menu = ReglageDebit;
                      		              else Menu = ChoixSeringue;

                            Menu_1 = ChoixSeringue;
        break;

        case  ReglageDebit: if (Menu_1 != Menu)
                            {
                                Regdebit(&dizaines,&unites,&diziemes);
                                sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
                                sprintf(display_buffer_ligne1,"ECHP>Arr SET>RUN");
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                            }
                            if (BP == ECHAP) Menu = Arret;
                      		    else if (BP == SET) Menu = Marche;
                      		               else Menu = ReglageDebit;

                          Menu_1 = ReglageDebit;
        break;

        };

      };
}
